# Kodi 17.6 compiled on Fatdog64-720

### What's new since Kodi 17.3 for Fatdog64-710

* Kodi 17.6 and internal FFmpeg 3.1.11.
* Required avahi package not included; it's already in FD-720 basesfs.
* Update libbluray 1.0.1 and samba4 4.7.3 from Fatdog64-720 repository.
* Update libass 0.14.0, libmicrohttpd 0.9.58, libnfs 2.0.0.
* So long as the Kodi SFS is loaded the Package Manager will handle the
  included packages as being fully installed.

## Main features of this build (tested)

* Kodi 17.6 with internal FFmpeg 3.1.11.
* ALSA yes, pulseaudio no.
* Direct browse LAN media (SMB, NFS, uPnP/DLNA).
* Play back/browse local & LAN media internet streming.
* Avahi yes, AirPlay no, Wii no, CEC TV remote support yes (untested),
* Common Kodi features, such as media library with scrapers, plugins, remote
  control web interface, etc.

## Known issues

* -

## Tips

* Inside the player press M to access its quick buttons (start/stop,
  back/forward, settings)
* Press C for the context menu of a selected media item
* Press P to play a media item, like a DVD or audio folder, etc.
* Press \ (backslash) to toggle full-screen mode.
* Try the Chorus2 remote playback interface. Browse http://localhost:8080.

### Installing

Use SFS Manager to download and load the latest `kodi_720` SFS for
Fatdog64-720.  This version isn't suitable for Fatdog64-710.

### Connecting to network shares

Due to Fatdog64-720 updates and Linux kernel breaking changes (security
improvements due to SMB1), your old SMB network locations will no longer work;
they may need to be deleted and re-created.

Symptom: Kodi keeps asking for the user name/password of the SMB network
location; no going further.

Troubleshoot: Turn on SMB logging and verify error messages:
1. Start Kodi and go to: Settings > System settings > Logging > Specify
   component-specific logging.  Enable Verbose logging for the SMB library.
   Effect: Kodi logs SMB events to stderr - including cleartext passwords.
2. Restart Kodi from the command line in a terminal window. Add a new SMB
   network location (Video/Audio > Add files... > Browse > Network location);
   enter server and share names; enter correct user and password, OK. No login,
   Kodi repeats the user/password prompt. The terminal output will likely show
   this error message:
```
Server does not support EXTENDED_SECURITY  but 'client use spnego = yes' and 'client ntlmv2 auth = yes' is set
```

**Solution 1:** Change protocol version setting.

Start Kodi and go to System > Service settings > SMB client.
Change "Maximum protocol version" to "SMBv1".
Then restart Kodi and try connecting to the SMB network location again.

**Solution 2:** Edit SMB configuration file; re-create network locations.

Create file `~/.kodi/.smb/user.conf` with the following contents (use
one Tab to indent the lines):
```
[global]
	client use spnego = no
	client ntlmv2 auth = no
```
Then restart Kodi and try connecting to the SMB network location again.

Notes:
It is assumed that file `~/.kodi/.smb/smb.conf` exists and includes the
following line:
```
	include = /root/.kodi/.smb/user.conf
```
If not, re-create `~/.kodi/.smb/smb.conf` (delete it first): When the "Add
network location" dialog fails in step #2, work your way back through the
prompts until Kodi asks if you want to add the failing network location
"anyway"; answer yes.

### Connecting to network shares - alternative method

Fatdog64 users:

If you don't want to troubleshoot connecting to SMB network location from Kodi,
you can use the Network Shares application to mount a network share, then add
the mounted directory as a Kodi video/audio source. To start the Network Shares
application, open folder `~/Desktop/Shares` and click the `Network` icon.

----

**=============**

**Old README for Kodi 17.3 for Fatdog64-710**

**=============**

[Shared folder](https://drive.google.com/drive/folders/0B932fvbgcXnMR3VWWkVJUTRmQU0)
All Kodi 17.3 builds.

### Must do when upgrading from version 2017-07-17 or earlier

You only need to do this once. Before _loading_ the new Kodi SFS, or installing
the Kodi or avahi packages, open a terminal window and type:

```
getent passwd avahi && userdel avahi && rm /var/mail/avahi 
```

Expect this ouput:

```
avahi:x:214:214:Avahi Daemon Owner:/dev/null:/bin/false
```

## TLDR;

Choose one of the following:

* One stop: Download and load the "Kodi with Avahi" SFS - minimal changes to
  your system, can be unloaded at will.
  **=>** `kodi_17_3_avahi_0_6_32-2017????-x86_64-??.sfs`
* Two stops: Download and load the "Kodi" (without awahi) SFS; download and
  install the avahi TXZ package - auto-start avahi service at boot time.
  **=>** `kodi_17_3-2017????-x86_64-??.sfs`
  **=>** `avahi-0.6.32-x86_64-5.txz`
* Many stops: Download and install kodi, avahi and all required TXZ packages -
  Install and forget, 199 MB minimum disk space required.
  **=>** Read full package list in section _Installation_.

## Quick Start / Upgrading

* Download all the TXZ packages in the top level of the shared folder
  [shared folder](https://drive.google.com/drive/folders/0B932fvbgcXnMR3VWWkVJUTRmQU0).
  Alternatively download and load one of the two Kodi SFS files, see section
  _TLDR;_.
* If python2 isn't available install it from the package manager, or load the
  Fatdog64 devx SFS from the SFS manager.
* Open a terminal window and type `kodi &`. Watch for error messages about
  possibly missing dynamic libraries.  Alternatively, run Kodi from its icon
  located in the Multimedia section of the panel menu.

If you are upgrading from a previous (test) build, start Kodi and go to
Settings (click the gear icon) Event log, click the Version Check event line,
if any, and finally the Update button.

## Main Features

* Kodi 17.3 with FFmpeg 3.1.6 included
* ALSA yes, pulseaudio no
* Play back local media, network media, internet streming media
* SMB and NFS network share browsing
* Media Library with Internet Movie DB and local DB scrapers (for covers,
  plots, fanart, etc.)
* CEC TV remote support yes, Avahi yes, AirPlay no, Wii no
* All other common Kodi features are supposed to work

## Known Issues

* -

## Tips

* Inside the player press M to access its quick buttons (start/stop,
  back/forward, settings)
* Press C for the context menu of a selected media item
* Press P to play a media item, like a DVD or audio folder, etc.
* Press \ (backslash) to toggle full-screen mode.
* To control Kodi with a remote control app, such as Yatse for Android devices,
  start service `avahi-daemon` in the Fatdog64 Control Panel Service Manager
  applet.  See section _Remote Controls_ below.
* There is an experimental binary add-ons package. Read section _Add-ons_.

## Installation - TXZ Packages and SFS

Kodi **requires**: `avahi` `libass` `crossguid` `yajl` `tinyxml`
`libmicrohttpd` `libssh` `libcdio` `librtmp` `python` `samba4_libs_kodi`
`libmysqlclient_mariadb_kodi`.
It **suggests**: `libnfs` `libbluray` `libcec` `libssh` `libcdio`
`samba4` `mariadb`.

If you prefer full versions, you can install `samba4` and `mariadb` from the
official repository instead of the cut-down versions `samba4_libs_kodi` and
`libmysqlclient_mariadb_kodi`.

Minimum TXZ package set required to install Kodi. The "kodi with avahi" SFS
includes all the packages except the ones marked with `*`.  The "kodi without
avahi" SFS also does not include avahi.

```
avahi-0.6.32-x86_64-5: service discovery aka zeroconf                    [2.3M] !
crossguid-20160705-x86_64-1: Lightweight cross platform C++ GUID/UUID li [40K] 
kodi-17.3-x86_64-4: Multi-platform Media Center                          [73M] 
libass-0.13.5-x86_64-1: Subtitle renderer for the ASS/SSA                [260K]
libcdio-0.94-x86_64-1: 0.94 CD I/O library                               [1.4M]
libmicrohttpd-0.9.54-x86_64-1: HTTP server C library                     [480K]
libmysqlclient_mariadb_kodi-10.1.10-x86_64-1: 10.1.10 MySQL client libra [2.7M]
libssh-0.7.5-x86_64-1: 0.7.5 library                                     [640K]
python-2.7.11-x86_64-1: Python programming language                      [98M]  *
samba4_libs_kodi-4.0.26-x86_64-1: 4.0.26 SMB Client Libraries            [17M] 
tinyxml-2.6.2-x86_64-1: A small XML parser                               [220K]
yajl-2.1.0-x86_64-1: Yet Another JSON Library                            [220K]
```

Optional TXZ packages that enable additional features. the Kodi SFS files don't
include the packages marked with `*`:

```
libbluray 0.9.3: Bluray access library                                   [340K] *
libcec-4.0.2-x86_64-1: library for the Pulse-Eight USB-HDMI CEC Adapter  [1.5M]
libnfs-1.11.0-x86_64-1: NFS client library                               [560K]
libp8_platform-2.1.0.1-x86_64-1: platform support library                [300K]
lockdev-1.0.3-x86_64-1: device locking library                           [100K]
```

### Add-ons

This Kodi build includes just the default add-ons for the Linux platform.
Since 2017-07-17 several binary add-ons are packaged as a separate SFS file,
which is to be considered _experimental_. It includes 17 audiodecoders, 2
inputstreams (adaptive and rtmp), joystick, 19 PVRs, 20 screensavers, and 6
visualizations. To enable an add-on click "Add-ons" in the left pane, click
"Enter add-on browser" if necessary, click "My add-ons" then the category,
i.e., "Look & feel" for "ScreenSaver" and "Visualization", and so on.

### Remote Controls - Auto-discovery

Auto-discovery (Zeroconf) is based on package `avahi`, and the `avahi-daemon`
must be running, which enables remote control apps like Yatse or Kore to
discover Kodi in your home network.

Start service `avahi-daemon` from the Fatdog64 Control Panel Service
Manager applet. Start Kodi. Make sure that Kodi is configured as explained
[here](http://kodi.wiki/view/web_interface). You can test that Kodi (XBMC) is
publishing its services to the Avahi daemon:

```
# avahi-browse _services._dns-sd._udp -t
+   eth0 IPv6 _xbmc-jsonrpc           _tcp                 local
+   eth0 IPv6 _xbmc-events            _udp                 local
+   eth0 IPv6 _xbmc-jsonrpc-h         _tcp                 local
+   eth0 IPv6 _http                   _tcp                 local
+   eth0 IPv6 _ssh                    _tcp                 local
+   eth0 IPv6 _sftp-ssh               _tcp                 local
+   eth0 IPv4 _xbmc-jsonrpc           _tcp                 local
+   eth0 IPv4 _xbmc-events            _udp                 local
+   eth0 IPv4 _xbmc-jsonrpc-h         _tcp                 local
+   eth0 IPv4 _http                   _tcp                 local
+   eth0 IPv4 _ssh                    _tcp                 local
+   eth0 IPv4 _sftp-ssh               _tcp                 local
```

* `avahi-discovery-standalone` monitors discoverable services in a GUI.

Install and run Yatse on your Android device and follow the wizard to discover
your Kodi device, that is Fatdog64 running Kodi, in your home network.

### Avahi Forward-Compatibility

Recently, an avahi package has made its appearance in the official Fatdog64
repository. The version label is 0.7, which is newer than the avahi version in
this Kodi build. I have tested this build with avahi 0.7 and found no issues.
However, since version 0.6.32 has been tested for much longer, I decided to
keep the older avahi version in this package, and leave the newer version for a
future build - the timeframe of which will follow that of the next release of
Fatdog64 itself.  Built-in avahi support is planned for the next Fatdog64
release. Meanwhile, based on my limited tests, you can mix this Kodi build with
avahi 0.7. Load the "Kodi without avahi" SFS for that.

## Changelog

**2017-09-02**

_While Kodi 17.4 is the latest official bug-fix release, changes don't involve
Fatdog64 Linux, so this build stays at Kodi 17.3._

This is the last Release Candidate build. It will go to final in a few days if
no significant issues are reported.

* Changes to avahi for compatibility with future Fatdog64 versions. Current
  users need to perform a manual upgrade fixup. See section at the beginning of
  this document.
* Avahi stopped working in builds after 2017-05-30 and no one noticed. Working
  again now.

**2017-07-17**

* Add several binary addons in a separate SFS file.

**2017-07-12**

* Enable ffmpeg in kodi package to link in the system rtmp library.
* Make kodi build recipe reproducible without an active internet connection.

**2017-05-30**

* Update packaging (rev 4).
* Update packaging (rev 3).

**2017-05-28**

* Kodi 17.3
  [Security update](https://kodi.tv/article/kodi-v173-minor-bug-fix-and-security-release).
* Add Zeroconf support.
* Add desktop file and icons.
* Update libmicrohttpd 0.9.54.

**2017-05-20**

* First test release. Kodi 17.1.
